//LukeLightSabery.cs

datablock AudioDescription(SaberLoop3d : AudioClosest3d)
{
   isLooping = "1";
   //isStreaming = "1";
};

datablock AudioProfile(LightSaberDrawSound)
{
   filename    = "./LightSaberDraw.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(LightSaberHitSound)
{
   filename    = "./LightSaberHit.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(LightSaberAttackSound)
{
   filename    = "./LightSaberAttack.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(LightSaberIdleSound)
{
   filename    = "./LightSaberIdle.wav";
   description = SaberLoop3d;
   preload = true;
};


//effects
datablock ParticleData(LukeLightSaberExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 1;
   constantAcceleration = 0.0;
   spinRandomMin = -180;
   spinRandomMax = 180;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 300;
   textureName          = "./spark";
   colors[0]     = "1 0.25 0 0.9";
   colors[1]     = "0.6 0.6 0.9 0.0";
   sizes[0]      = 0.2;
   sizes[1]      = 0.1;
};

datablock ParticleEmitterData(LukeLightSaberExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "LukeLightSaberExplosionParticle";

   uiName = "LukeLightSaber Hit";
};

datablock ExplosionData(LukeLightSaberExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   soundProfile = LightSaberHitSound;

   particleEmitter = LukeLightSaberExplosionEmitter;
   particleDensity = 20;
   particleRadius = 0.2;

   faceViewer     = false;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "0.2 0.2 0.8";
   lightEndColor = "0 0 0";
};


//projectile
AddDamageType("LukeLightSaber",   '<bitmap:add-ons/Weapon_LukeLightSaber/CI_LukeLightSaber> %1',    '%2 <bitmap:add-ons/Weapon_LukeLightSaber/CI_LukeLightSaber> %1',0.75,1);
datablock ProjectileData(LukeLightSaberProjectile)
{
   directDamage        = 35;
   directDamageType  = $DamageType::LukeLightSaber;
   radiusDamageType  = $DamageType::LukeLightSaber;
   explosion           = LukeLightSaberExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "1 0 0";

   uiName = "LukeLightSaber Slice";
};


//////////
// item //
//////////
datablock ItemData(LukeLightSaberItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./LukeLightSaber.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Luke Light Saber";
	iconName = "./icon_LukeLightSaber";
	doColorShift = true;
	colorShiftColor = "1 1 1 1.000";

	 // Dynamic properties defined by the scripts
	image = LukeLightSaberImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(LukeLightSaberImage)
{
   // Basic Item properties
   shapeFile = "./LukeLightSaber.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "-0.01 0.01 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = LukeLightSaberItem;
   ammo = " ";
   projectile = LukeLightSaberProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "1 1 1 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = LightSaberDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateSound[3]                    = LightSaberAttackSound;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";
};


function LukeLightSaberImage::onMount(%this, %obj, %slot)
{
	%obj.playAudio(0, LightSaberIdleSound);
}

function LukeLightSaberImage::onUnMount(%this, %obj, %slot)
{
	%obj.stopAudio(0);
	%obj.playthread(2, root);
}

function LukeLightSaberImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function LukeLightSaberImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}